HostServices (JavaFX 25)
Description: declaration: module: javafx.graphics, package: javafx.application, class: HostServices

# Class HostServices

java.lang.Object
javafx.application.HostServices

public final class HostServices extends Object
This class provides HostServices for an Application. This includes methods to get the code base and document base for an Application, and to show a web page in a browser.

Since:
  JavaFX 2.0

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final String`
  `getCodeBase()`
  Gets the code base URI for this application.
  `final String`
  `getDocumentBase()`
  Gets the document base URI for this application.
  `final String`
  `resolveURI(String base, String rel)`
  Resolves the specified relative URI against the base URI and returns the resolved URI.
  `final void`
  `showDocument(String uri)`
  Opens the specified URI in a new browser window or tab.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### getCodeBase

    public final String getCodeBase()
    Gets the code base URI for this application. This method returns the directory containing the application jar file. If the application is not packaged in a jar file, this method returns the empty string.
    Returns:
      the code base URI for this application.

  - ### getDocumentBase

    public final String getDocumentBase()
    Gets the document base URI for this application. This method returns the URI of the current directory.
    Returns:
      the document base URI for this application.

  - ### resolveURI

    public final String resolveURI(String base, String rel)
    Resolves the specified relative URI against the base URI and returns the resolved URI.

    Example:

            HostServices services = getHostServices();
            String myImage = services.resolveURI(services.getDocumentBase(),
                                                 "image.jpg");
            Image image = new Image(myImage);

    Parameters:
      `base` - the base URI against which to resolve the relative URI
      `rel` - the relative URI to be resolved
    Returns:
      the fully resolved URI.
    Throws:
      `NullPointerException` - if either the `base` or the `rel` strings are null.
      `IllegalArgumentException` - if there is an error parsing either the `base` or `rel` URI strings, or if there is any other error in resolving the URI.

  - ### showDocument

    public final void showDocument(String uri)
    Opens the specified URI in a new browser window or tab. The determination of whether it is a new browser window or a tab in an existing browser window will be made by the browser preferences. Note that this will respect the pop-up blocker settings of the default browser; it will not try to circumvent them.
    Parameters:
      `uri` - the URI of the web page that will be opened in a browser.